> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trackstarhq.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get All Products

> Returns all Products for the WMS connection associated with the provided access token.



## OpenAPI

````yaml get /wms/products
openapi: 3.1.0
info:
  description: >

    Trackstar is a Unified API that provides standard endpoints for Supply Chain
    Logistics. We currently offer an API for Warehouse Management Systems (WMS).
  title: Trackstar API
  version: 0.1.0
servers:
  - description: Trackstar API
    url: https://production.trackstarhq.com
security: []
tags: []
externalDocs:
  description: Trackstar API Documentation
  url: https://docs.trackstarhq.com
paths:
  /wms/products:
    get:
      tags:
        - wms
        - Products
      summary: Get All Products
      description: >-
        Returns all Products for the WMS connection associated with the provided
        access token.
      operationId: get_wms_get_products
      parameters:
        - in: header
          name: x-trackstar-api-key
          description: Your organization-level Trackstar API key.
          schema:
            type: string
            example: <x-trackstar-api-key>
          required: true
        - in: header
          name: x-trackstar-access-token
          description: >-
            Your user's access token for a specific integration (ShipHero,
            Extensiv, etc).
          schema:
            type: string
            example: <x-trackstar-access-token>
          required: true
        - in: query
          name: page_token
          description: >-
            The page token to use to retrieve the next page of results. If this
            field is omitted, there are no subsequent pages.
          schema:
            type:
              - string
              - 'null'
            example: page_token
          required: false
        - in: query
          name: limit
          description: The maximum number of items to return. The default is 1000.
          schema:
            type: integer
            minimum: 1
            maximum: 1000
            example: 1000
          required: false
        - in: query
          name: ids
          schema:
            $ref: '#/components/schemas/WmsProductIdsQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: created_date
          description: >-
            Use this parameter to retrieve items filtered to a specific date
            range. For example, to get all items between 2023-03-10 and
            2023-03-22, you would send
            `created_date[gte]=2023-03-10T00:00:00Z&created_date[lte]=2023-03-22T00:00:00Z.`
            See the [filtering docs](/how-to-guides/about-the-api#filtering) for
            more. The date format must always be YYYY-MM-DDTHH:MM:SSZ. 
             Note: it is much more efficient to use a combination of `gte`/`lte` than it is to use `gt`/`lt`.
          schema:
            $ref: '#/components/schemas/WmsProductCreated_DateQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: updated_date
          description: Same syntax as `created_date`.
          schema:
            $ref: '#/components/schemas/WmsProductUpdated_DateQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: trackstar_created_date
          description: Same syntax as `created_date`.
          schema:
            $ref: '#/components/schemas/WmsProductTrackstar_Created_DateQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: trackstar_updated_date
          description: Same syntax as `created_date`.
          schema:
            $ref: '#/components/schemas/WmsProductTrackstar_Updated_DateQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: trackstar_tags
          description: >-
            Filter by trackstar tags. Dict-shaped tags should be queried as
            "key:value" strings.
          schema:
            $ref: '#/components/schemas/WmsProductTrackstar_Tags_FlatQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: warehouse_customer_id
          description: The ID of the customer associated with the resource
          schema:
            $ref: '#/components/schemas/WmsProductWarehouse_Customer_IdQueryParam'
          required: false
          style: deepObject
          explode: true
        - in: query
          name: sku
          description: The SKU of the product.
          schema:
            $ref: '#/components/schemas/WmsProductSkuQueryParam'
          required: false
          style: deepObject
          explode: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WmsProductsListEndpoint'
          description: Successful response
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationError'
          description: Validation error
components:
  schemas:
    WmsProductIdsQueryParam:
      type: object
      properties:
        in:
          type: array
          description: >-
            A comma-separated list of resource IDs. If provided, all other query
            params are ignored.
          example: resource_id_1,resource_id_2
          items:
            type: string
            description: ''
      required:
        - in
      additionalProperties: false
      title: WmsProductIdsQueryParam
    WmsProductCreated_DateQueryParam:
      type: object
      properties:
        eq:
          type: string
          format: date-time
          description: ''
          example: '2023-03-15T13:45:30Z'
        neq:
          type: string
          format: date-time
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        gt:
          type: string
          format: date-time
          description: ''
        gte:
          type: string
          format: date-time
          description: ''
        lt:
          type: string
          format: date-time
          description: ''
        lte:
          type: string
          format: date-time
          description: ''
      additionalProperties: false
      title: WmsProductCreated_DateQueryParam
    WmsProductUpdated_DateQueryParam:
      type: object
      properties:
        eq:
          type: string
          format: date-time
          description: ''
          example: '2023-03-15T13:45:30Z'
        neq:
          type: string
          format: date-time
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        gt:
          type: string
          format: date-time
          description: ''
        gte:
          type: string
          format: date-time
          description: ''
        lt:
          type: string
          format: date-time
          description: ''
        lte:
          type: string
          format: date-time
          description: ''
      additionalProperties: false
      title: WmsProductUpdated_DateQueryParam
    WmsProductTrackstar_Created_DateQueryParam:
      type: object
      properties:
        eq:
          type: string
          format: date-time
          description: ''
          example: '2023-03-15T13:45:30Z'
        neq:
          type: string
          format: date-time
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        gt:
          type: string
          format: date-time
          description: ''
        gte:
          type: string
          format: date-time
          description: ''
        lt:
          type: string
          format: date-time
          description: ''
        lte:
          type: string
          format: date-time
          description: ''
      additionalProperties: false
      title: WmsProductTrackstar_Created_DateQueryParam
    WmsProductTrackstar_Updated_DateQueryParam:
      type: object
      properties:
        eq:
          type: string
          format: date-time
          description: ''
          example: '2023-03-15T13:45:30Z'
        neq:
          type: string
          format: date-time
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            format: date-time
            description: ''
        gt:
          type: string
          format: date-time
          description: ''
        gte:
          type: string
          format: date-time
          description: ''
        lt:
          type: string
          format: date-time
          description: ''
        lte:
          type: string
          format: date-time
          description: ''
      additionalProperties: false
      title: WmsProductTrackstar_Updated_DateQueryParam
    WmsProductTrackstar_Tags_FlatQueryParam:
      type: object
      properties:
        contains:
          type: array
          description: Comma-separated.
          example: tag_1,tag_2:value_2
          items:
            type: string
            description: ''
        not_contains:
          type: array
          description: Comma-separated.
          items:
            type: string
            description: ''
      additionalProperties: false
      title: WmsProductTrackstar_Tags_FlatQueryParam
    WmsProductWarehouse_Customer_IdQueryParam:
      type: object
      properties:
        eq:
          type: string
          description: ''
          example: warehouse_cust_id
        neq:
          type: string
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            description: ''
        contains:
          type: string
          description: ''
        not_contains:
          type: string
          description: ''
      additionalProperties: false
      title: WmsProductWarehouse_Customer_IdQueryParam
    WmsProductSkuQueryParam:
      type: object
      properties:
        eq:
          type: string
          description: ''
          example: sku
        neq:
          type: string
          description: ''
        in:
          type: array
          description: Comma-separated.
          items:
            type: string
            description: ''
        nin:
          type: array
          description: Comma-separated.
          items:
            type: string
            description: ''
        contains:
          type: string
          description: ''
        not_contains:
          type: string
          description: ''
        is_null:
          type: boolean
          description: Filter by whether the field is null.
          example: true
      additionalProperties: false
      title: WmsProductSkuQueryParam
    WmsProductsListEndpoint:
      type: object
      properties:
        data:
          type: array
          description: ''
          items:
            $ref: '#/components/schemas/WmsProductApiItemSchema'
        next_token:
          type:
            - string
            - 'null'
          description: >-
            See [pagination](/how-to-guides/about-the-api#pagination) for more
            details.
          example: next_token
        total_count:
          type: integer
          description: The number of items returned.
          example: 1
      required:
        - data
        - next_token
        - total_count
      additionalProperties: false
      title: WmsProductsListEndpoint
    ValidationError:
      properties:
        error:
          type: string
        detail:
          type: object
          properties:
            <location>:
              type: object
              properties:
                <field_name>:
                  type: array
                  items:
                    type: string
      required:
        - error
      type: object
      title: ValidationError
    WmsProductApiItemSchema:
      type: object
      properties:
        id:
          type: string
          description: The unique ID of the product.
          example: product_id
        warehouse_customer_id:
          type:
            - string
            - 'null'
          description: >-
            The ID of the merchant/tenant/customer that owns the product. Can be
            passed into the [Warehouse
            Customer](/api-reference/wms-api/warehouse-customers/get-item)
            endpoint for more details.
          example: warehouse_customer_id
        created_date:
          type: string
          format: date-time
          description: The date the product was created.
          example: '2022-01-01T00:00:00Z'
        updated_date:
          type: string
          format: date-time
          description: The date the product was last updated.
          example: '2022-01-02T05:05:05Z'
        name:
          type: string
          description: name
          example: name
        sku:
          type:
            - string
            - 'null'
          description: sku
          example: sku
        gtin:
          type:
            - string
            - 'null'
          description: The Global Trade Item Number of the product. i.e. UPC, EAN, or ISBN.
          example: gtin
        unit_price:
          type:
            - number
            - 'null'
          description: The price of the product.
          example: 10.99
        inventory_items:
          type: array
          description: A list of inventory items associated with the product.
          example:
            - inventory_item_id: id1
              sku: sku1
              unit_quantity: 1
            - inventory_item_id: id2
              sku: sku2
              unit_quantity: 1
          items:
            $ref: '#/components/schemas/ProductInventoryItems'
        is_kit:
          type: boolean
          description: ''
          example: true
        active:
          type: boolean
          description: Whether the product is active.
          example: true
        supplier_object:
          anyOf:
            - $ref: '#/components/schemas/ProductSupplier'
            - type: 'null'
        country_of_origin:
          type:
            - string
            - 'null'
          description: The country of origin of the product.
          example: USA
        harmonized_code:
          type:
            - string
            - 'null'
          description: The harmonized HS code of the product.
          example: '123456'
        supplier_products:
          type: array
          description: A list of supplier products associated with the product.
          example:
            - supplier_id: id1
              supplier_name: name1
              external_id: ext_id1
              unit_cost: 1
            - supplier_id: id2
              supplier_name: name2
              external_id: ext_id2
              unit_cost: 2.5
          items:
            $ref: '#/components/schemas/ProductSupplierProducts'
        categories:
          type: array
          description: A list of category names associated with the product.
          example:
            - Electronics
            - Accessories
          items:
            type: string
            description: ''
        image_urls:
          type: array
          description: A list of image URLs associated with the product.
          example:
            - https://example.com/image1.jpg
          items:
            type: string
            description: ''
        external_system_url:
          type:
            - string
            - 'null'
          description: URL link to the product in the external system (WMS/Freight etc).
          example: https://example.com/product/123
        trackstar_tags:
          type:
            - array
            - 'null'
          description: >-
            A list of custom tags associated with the resource. A tag can be
            either a string or a dictionary with one key-value pair.
          example:
            - tag1
            - tag2
            - tag3: value3
          items: {}
        additional_fields:
          type: object
          description: Integration-specific fields
          example:
            key: value
          additionalProperties: {}
        trackstar_created_date:
          type: string
          format: date-time
          description: ''
        trackstar_updated_date:
          type: string
          format: date-time
          description: ''
      required:
        - active
        - additional_fields
        - categories
        - country_of_origin
        - created_date
        - external_system_url
        - gtin
        - harmonized_code
        - id
        - image_urls
        - inventory_items
        - is_kit
        - name
        - sku
        - supplier_object
        - supplier_products
        - trackstar_created_date
        - trackstar_tags
        - trackstar_updated_date
        - unit_price
        - updated_date
        - warehouse_customer_id
      additionalProperties: false
      title: WmsProductApiItemSchema
    ProductInventoryItems:
      type: object
      properties:
        inventory_item_id:
          type: string
          description: >-
            ID of the inventory item. Can be passed into the
            [Inventory](/api-reference/wms-api/inventory/get-item) endpoint for
            more details.
          example: inv_id
        sku:
          type:
            - string
            - 'null'
          description: ''
        unit_quantity:
          type: integer
          description: The number of units of the inventory item in the product.
          example: 0
      required:
        - inventory_item_id
        - sku
        - unit_quantity
      additionalProperties: false
      title: ProductInventoryItems
    ProductSupplier:
      type: object
      properties:
        supplier_id:
          type: string
          description: The ID of the supplier.
          example: supplier_id
        supplier_name:
          type:
            - string
            - 'null'
          description: The name of the supplier.
          example: supplier_name
      required:
        - supplier_id
        - supplier_name
      additionalProperties: false
      title: ProductSupplier
    ProductSupplierProducts:
      type: object
      properties:
        supplier_id:
          type: string
          description: ID of the supplier.
          example: sup_id
        supplier_name:
          type:
            - string
            - 'null'
          description: Name of the supplier.
          example: sup_name
        external_id:
          type:
            - string
            - 'null'
          description: The external ID of the product from the supplier.
          example: ext_id
        unit_cost:
          type:
            - string
            - 'null'
          description: The cost of the product from the supplier.
          example: unit_cost
      required:
        - external_id
        - supplier_id
        - supplier_name
        - unit_cost
      additionalProperties: false
      title: ProductSupplierProducts

````